#include "stm32f10x.h"

volatile uint8_t state = 0;
volatile uint8_t connected = 0;
volatile uint8_t firstLf = 0;
volatile uint8_t firstChar = 0;

void Delay(volatile unsigned int delay)
{
  for(;delay>0;delay--);
}

void init_UART() {
  	
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA | RCC_APB2Periph_USART1, ENABLE);
	
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_2MHz;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0 | GPIO_Pin_2;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
	GPIO_Init(GPIOA, &GPIO_InitStructure);
	
	USART_InitTypeDef USART_InitStructure;
	USART_InitStructure.USART_BaudRate = 19200;
	USART_InitStructure.USART_WordLength = USART_WordLength_8b;
	USART_InitStructure.USART_StopBits = USART_StopBits_1;
	USART_InitStructure.USART_Parity = USART_Parity_No;
	USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
	USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;
	USART_Init(USART1, &USART_InitStructure);
	USART_ITConfig(USART1, USART_IT_RXNE, ENABLE); 
	USART_Cmd(USART1, ENABLE);
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_0);
	NVIC_InitTypeDef NVIC_InitStructure;
	NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
	NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
	NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
	NVIC_Init(&NVIC_InitStructure);
	
}

int main(void)
{
	uint8_t stateOld = 3;
	init_UART();
	while(1){
		while(!connected);
		GPIO_SetBits(GPIOA, GPIO_Pin_2);
		while (connected) {
			state = GPIO_ReadInputDataBit(GPIOA, GPIO_Pin_1);
			if (state != stateOld) {
				stateOld = state;
				while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
				if (state==0) USART_SendData(USART1, 'P'); else USART_SendData(USART1, 'N');
				Delay(600000);
			}
		}
		GPIO_ResetBits(GPIOA, GPIO_Pin_2);
	}
}

void USART1_IRQHandler(void)
{
	if (USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
	{
		char data = USART_ReceiveData(USART1);
		if(connected){
			if (data=='a') GPIO_SetBits(GPIOA, GPIO_Pin_0);
			if (data=='b') GPIO_ResetBits(GPIOA, GPIO_Pin_0);
			if (data=='r') {
				while(USART_GetFlagStatus(USART1, USART_FLAG_TXE) == RESET);
				if (state==0) USART_SendData(USART1, 'P'); else USART_SendData(USART1, 'N');
			}
		}
		if(firstLf) {
			if(!firstChar) firstChar = data;
		}
		if (data=='\n'){
			if (firstLf) {
				firstLf = 0;
				if (firstChar == 'C') {
					connected = 1;
				}
				if (firstChar == 'D') {
					connected = 0;
				}
				firstChar = 0;
			} else firstLf = 1;
		}
	}
}
